<template>
    <div :class="$style.chart">
        <div class="text1" :class="$style.title">{{ title }}</div>
        <Line :data="chartData" :options="chartOptionsObj"> </Line>
    </div>
</template>

<script>
import { Chart as ChartJS, CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip } from 'chart.js'
import { Line } from 'vue-chartjs'
import { formatBigNumbers } from '@/utils/utils'
// eslint-disable-next-line
// import * as chartConfig from './chartConfig.js'

ChartJS.register(CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip)
ChartJS.register({
    id: 'custom_line',
    afterTooltipDraw: function (chart) {
        if (chart.tooltip._active && chart.tooltip._active.length) {
            let ctx = chart.ctx,
                activePoint = chart.tooltip._active[0],
                x = activePoint.element.x,
                topY = chart.scales.y.top,
                bottomY = chart.scales.y.bottom
            ctx.beginPath()
            ctx.moveTo(x, topY)
            ctx.lineTo(x, bottomY)
            ctx.lineWidth = 1
            ctx.strokeStyle = '#1c1726'
            ctx.stroke()
            ctx.restore()
        }
    },
})

export default {
    name: 'ChartComponent',
    components: {
        Line,
    },

    props: {
        title: {
            type: String,
            default: '',
        },
        chartData: {
            type: Object,
            default: () => ({}),
        },
        chartOptions: {
            type: Object,
            default: () => ({}),
        },
        labelOptions: {
            type: Object,
            default: () => ({}),
        },
    },

    data() {
        return {
            defaultChartOptions: {
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            drawTicks: false,
                        },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
            },
        }
    },

    computed: {
        ticksXNumber() {
            let num = Math.ceil((window.innerWidth - 64) / 90 / 2)
            return num + (1 - (num % 2))
        },
        chartOptionsObj() {
            return {
                ...this.chartOptions,
                layout: {
                    padding: {
                        left: 10,
                        right: 10,
                        top: 10,
                        bottom: 10,
                    },
                },
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                pointHoverBackgroundColor: 'white',
                pointHoverRadius: 5,
                hoverBorderWidth: '3',
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                            maxTicksLimit: 6,
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                            maxTicksLimit: this.ticksXNumber, // 5,
                            padding: 35,
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
                plugins: {
                    tooltip: {
                        mode: 'nearest',
                        // mode: 'average',

                        bodySpacing: 4,
                        padding: 16,
                        caretPadding: 12,
                        caretSize: 0,

                        xPadding: 20,
                        yPadding: 20,

                        backgroundColor: 'rgb(255, 255, 255)',
                        // borderColor: 'rgba(28, 23, 38, 0.85)',
                        borderColor: 'rgba(28, 23, 38, 0.03)',
                        borderWidth: 5,

                        boxShadow: '0px 15px 40px 0px rgba(28, 23, 38, 0.15)',
                        bodyColor: 'rgb(255, 0, 0, 0.15)',
                        titleColor: 'rgb(0, 0, 0)',
                        displayColors: false,

                        callbacks: {
                            title: function (context) {
                                let label = context[0].element.label
                                return label
                            },
                            label: function (context) {
                                let label = `${formatBigNumbers(context.parsed.y)} Impressions`
                                return label
                            },
                            labelColor: function () {
                                return {
                                    backgroundColor: 'rgb(0, 0, 0)',
                                }
                            },
                            labelTextColor: function () {
                                return 'rgb(0, 0, 0)' //'#1c1726'
                            },
                            ...this.labelOptions,
                        },
                    },
                },
            }
        },
    },
}
</script>

<style module>
.chart {
    height: 250px;
}
.title {
    margin-bottom: 16px;
    font-size: 16px;
    font-weight: 700;
    line-height: 20px;
}
</style>
